/*
    config.h


    flexemu, an MC6809 emulator running FLEX
    Copyright (C) 1997  W. Schwotzer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef __config_h__
#define __config_h__

/* Uncomment the following if You want native file system support */

#define NAFS

/* uncomment the following if You want X-Toolkit and Athena Widget support */

#define XTK

/* uncomment the following line if You want a simple X11 support
   (without Widgets) */

#define X11

/* uncomment the following if the Disassembler should display FLEX entry
   addresses by symbolic names */

#define FLEX_LABEL

/* uncomment the following line if You want to compile flexemu with
   an alternative MC6809 processor implementation. It's about 10% faster
   but only aproximates processor cycles. Good for checking processor
   implementations against each other */

/*#define FASTFLEX*/

/* uncomment the following line if You have X Pixmap Support installed
   needed to display a picture of the author. This option is only useful
   if XTK is defined.
   ATTENTION: if this define is not present and You compile with Makefile.tpl
   (not Imakefile) then You should remove '-lXpm' from Makefile.tpl */

#define XPM



/* DO NOT EDIT BEYOND THIS LINE */

#if defined(linux) || defined(ultrix) || defined(sun)
#ifndef UNIX
#define UNIX
#endif
#endif

#ifdef XTK
#ifndef X11
#define X11
#endif
#endif

#ifndef XTK
#ifdef XPM
#undef XPM
#endif
#endif

#endif /* ifdef __config_h__ */

