/*
    iodevice.cc


    flexemu, an MC6809 emulator running FLEX
    Copyright (C) 1997  W. Schwotzer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stddef.h>
#include "misc1.h"
#include "classes.h"
#include "iodevice.h"

/* abstract upper class for any memory-mapped I/O device */
/* contains the common protocol for any I/O device	 */


IoDevice::IoDevice()
{
}

IoDevice::~IoDevice()
{
}

void IoDevice::resetIo()
{
}

Byte IoDevice::readIo(Word offset)
{
	return 0xff;
}


void IoDevice::writeIo(Word offset, Byte val)
{
}

Byte IoDevice::read_rom(Word offset)
{
	return 0xff;
}

void IoDevice::write_rom(Word addr, Byte val)
{
	// ROM is not writable !!
}

