/*
    misc1.h


    flexemu, an MC6809 emulator running FLEX
    Copyright (C) 1997  W. Schwotzer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/



#ifndef __misc1_h__
#define __misc1_h__

#include "typedefs.h"

#define PROGRAMNAME	"Flexemu"
#define VERSION		"1.00"

#ifdef WIN32
#define PATHSEPARATOR		'\\'
#define PATHSEPARATORSTRING	"\\"
#else
#define PATHSEPARATOR		'/'
#define PATHSEPARATORSTRING	"/"
#endif

/* Names of Environment or Registry variables */


#define FLEXREG		"Software\\Gnu\\Flexemu\\" VERSION
#define FLEXDISKDIR	"FLEXDISKDIR"
#define FLEXDISKX	"FLEXDISKx"
#define FLEXCOLOR	"FLEXCOLOR"
#define FLEXINVERSE	"FLEXINVERSE"
#define FLEXWWWBROWSER	"FLEXWWWBROWSER"
#define FLEXDOCDIR	"FLEXDOCDIR"
#define FLEXMONITOR	"FLEXMONITOR"

#define BTST0(x) (x & 0x01 ? 1 : 0)
#define BTST1(x) (x & 0x02 ? 1 : 0)
#define BTST2(x) (x & 0x04 ? 1 : 0)
#define BTST3(x) (x & 0x08 ? 1 : 0)
#define BTST4(x) (x & 0x10 ? 1 : 0)
#define BTST5(x) (x & 0x20 ? 1 : 0)
#define BTST6(x) (x & 0x40 ? 1 : 0)
#define BTST7(x) (x & 0x80 ? 1 : 0)
#define BTST8(x) (x & 0x100 ? 1 : 0)
#define BTST15(x) (x & 0x8000 ? 1 : 0)
#define BTST16(x) (x & 0x10000L ? 1 : 0)

#define BSET7(x) (x |= 0x80)
#define BSET6(x) (x |= 0x40)
#define BSET5(x) (x |= 0x20)
#define BSET4(x) (x |= 0x10)
#define BSET3(x) (x |= 0x08)
#define BSET2(x) (x |= 0x04)
#define BSET1(x) (x |= 0x02)
#define BSET0(x) (x |= 0x01)

#define BCLR7(x) (x &= 0x7f)

#ifdef __cplusplus
extern void     strupper(char *pstr);
extern void     strlower(char *pstr);
extern Word     extend8(Byte x);
extern char     *binstr(Byte x);
extern char     *hexstr(Byte x);
extern char     *hexstr(Word x);
extern char     *ascchr(Byte x);
#ifndef WIN32
extern int      stricmp(const char *string1, const char *string2);
#endif
#endif /* ifdef __cplusplus */

#endif /* __misc1.h__ */
